Attribute VB_Name = "Rendering"
Option Explicit

Public Sub Render_start(move As Single)

    Dim i As Integer
    
    D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0
    
    D3DDevice.BeginScene
    
    D3DXMatrixLookAtLH matView, MakeVector(0, -70, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
    D3DDevice.SetRenderState D3DRS_DESTBLEND, 2
    
    D3DDevice.SetTexture 0, Texture_Frontground_Start
    D3DDevice.SetStreamSource 0, VBuffer_Frontground, Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60
    
    D3DXMatrixLookAtLH matView, MakeVector(0, -68, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.SetTexture 0, Texture_Background_Start
    D3DDevice.SetStreamSource 0, VBuffer_Background, Len(Background(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60

    D3DXMatrixLookAtLH matView, MakeVector(0, 0, 124), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView

    For i = 0 To 4
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, -3.8, -11 - i * 0.75, 0
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DDevice.SetTexture 0, Texture_Button_Start(i)
        If Int(Scroll_Color_Start(i)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Start(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Start(Int(Scroll_Color_Start(i))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    Next i

    For i = 0 To 6
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 2, -11 + i * 2, 0
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld

        D3DDevice.SetTexture 0, Texture_Credits(i)
        If Int(Credits_Color_Start(6 - i)) > 255 Or Int(Credits_Color_Start(6 - i)) < 0 Then
            D3DDevice.SetStreamSource 0, VBuffer_Credits(255), Len(Credit(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Credits(Int(Credits_Color_Start(6 - i))), Len(Credit(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    Next i
        
    fnt.Name = "Arial"
    fnt.Size = Int((10 / 1024) * D3DWindow.BackBufferWidth) '10
    Set MainFontDesc = fnt
    Set MainFont = D3DX.CreateFont(D3DDevice, MainFontDesc.hFont)
    
    TextRect.Top = Int((716 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((736 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((822 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFF2222CC, Version, TextRect, DT_TOP Or DT_LEFT
    
    D3DXMatrixIdentity matView
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.EndScene
    
    D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Public Sub Render_Load(Load As String)

    Dim i As Integer
    
    D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0
    
    D3DDevice.BeginScene
    
    If Load = "Loading..." Or Load = "Weiter mit Klicken..." Then
        D3DXMatrixLookAtLH matView, MakeVector(0, -71, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
        D3DDevice.SetTransform D3DTS_VIEW, matView
        
        D3DDevice.SetTexture 0, Texture_Loading
        D3DDevice.SetStreamSource 0, VBuffer_Frontground, Len(Frontground(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60
    Else
        D3DXMatrixLookAtLH matView, MakeVector(0, -71, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
        D3DDevice.SetTransform D3DTS_VIEW, matView
        
        D3DDevice.SetTexture 0, Texture_Loading2
        D3DDevice.SetStreamSource 0, VBuffer_Frontground, Len(Frontground(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60
    End If
    
    fnt.Name = "Arial"
    fnt.Size = Int((10 / 1024) * D3DWindow.BackBufferWidth) '10
    Set MainFontDesc = fnt
    Set MainFont = D3DX.CreateFont(D3DDevice, MainFontDesc.hFont)
    
    TextRect.Top = Int((726 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((746 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((35 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((48 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, Load, TextRect, DT_TOP Or DT_LEFT
    
    D3DXMatrixIdentity matView
    D3DDevice.SetTransform D3DTS_VIEW, matView
        
    D3DDevice.EndScene
    
    D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Public Sub Render_main(move As Single)

    Dim i As Integer
    
    fnt.Name = "Arial"
    fnt.Size = Int((12 / 1024) * D3DWindow.BackBufferWidth)
    Set MainFontDesc = fnt
    Set MainFont = D3DX.CreateFont(D3DDevice, MainFontDesc.hFont)
    
    D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0
    
    D3DDevice.BeginScene
                
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
    D3DDevice.SetRenderState D3DRS_DESTBLEND, 2
    
    D3DXMatrixLookAtLH matView, MakeVector(0, -72, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.SetTexture 0, Texture_Frontground_Main
    D3DDevice.SetStreamSource 0, VBuffer_Frontground, Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60
    
    D3DXMatrixLookAtLH matView, MakeVector(0, -68, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.SetTexture 0, Texture_Background_Main

    D3DDevice.SetStreamSource 0, VBuffer_Background, Len(Background(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60

    D3DXMatrixLookAtLH matView, MakeVector(0, 0, 124), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.SetTexture 0, Texture_Front(Activeebene)
    D3DDevice.SetStreamSource 0, VBuffer_Ground(Ground_color), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    
    If s_Level = "Level1" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(0)
        If Int(Scroll_Color_Main(0)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(0))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 0, -0.75, 0
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
    If s_Level = "Level1" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(1)
        If Int(Scroll_Color_Main(1)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(1))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 2.3, -2.7, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
    If s_Level = "Level2" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(0)
        If Int(Scroll_Color_Main(2)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(2))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -0.75, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    If s_Level = "Level2" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(1)
        If Int(Scroll_Color_Main(3)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(3))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 1, -4, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
    If s_Level = "Level3" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(0)
        If Int(Scroll_Color_Main(4)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(4))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -0.75, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
    If s_Level = "Level3" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(1)
        If Int(Scroll_Color_Main(5)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(5))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -1, -3.8, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
    If s_Level = "Level4" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(0)
        If Int(Scroll_Color_Main(6)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(6))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -0.75, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    If s_Level = "Level4" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(1)
        If Int(Scroll_Color_Main(7)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(7))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -2.6, -2.7, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
    If s_Level = "Level5" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(0)
        If Int(Scroll_Color_Main(8)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(8))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -0.75, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    If s_Level = "Level5" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(1)
        If Int(Scroll_Color_Main(9)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(9))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    '##################rechts
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -8.2, -0.3, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetTexture 0, Texture_Button_Main(2)
    If Int(Scroll_Color_Main(10)) > 255 Then
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
    Else
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(10))), Len(Button(0))
    End If
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -2.3, -3.5, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetTexture 0, Texture_Button_Main(3)
    If Int(Scroll_Color_Main(11)) > 255 Then
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
    Else
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(11))), Len(Button(0))
    End If
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -1, -4.7, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetTexture 0, Texture_Button_Main(5)
    If Int(Scroll_Color_Main(12)) > 255 Then
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
    Else
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(12))), Len(Button(0))
    End If
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 1.2, -4.6, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
    If s_Level = "Level6" Then
        D3DDevice.SetTexture 0, Texture_Button_Main(8)
        If Int(Scroll_Color_Main(13)) > 255 Then
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
        Else
            D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(13))), Len(Button(0))
        End If
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 2.6, -3.5, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetTexture 0, Texture_Button_Main(9)
    If Int(Scroll_Color_Main(14)) > 255 Then
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(255), Len(Button(0))
    Else
        D3DDevice.SetStreamSource 0, VBuffer_Button_Main(Int(Scroll_Color_Main(14))), Len(Button(0))
    End If
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    TextRect.Top = Int((670 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((690 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((435 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((455 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Continues: " & CStr(s_Continue), TextRect, DT_TOP Or DT_LEFT
         
    TextRect.Top = Int((690 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((710 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((435 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((455 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Geld: " & CStr(s_Geld), TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((710 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((730 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((435 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((455 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Punktestand: " & CStr(s_Punkte), TextRect, DT_TOP Or DT_LEFT
    
    D3DXMatrixIdentity matView
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.EndScene
    
    D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Public Sub Render_shop(move As Single, ebene As Integer)
    
    On Error Resume Next

    D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0
    
    D3DDevice.BeginScene
                
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    'D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
    D3DDevice.SetRenderState D3DRS_DESTBLEND, 2
    
    D3DXMatrixLookAtLH matView, MakeVector(0, -71, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView '0,80,100
    
    D3DDevice.SetTexture 0, Texture_Frontground_Shop
    D3DDevice.SetStreamSource 0, VBuffer_Frontground, Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60
    
    D3DXMatrixLookAtLH matView, MakeVector(0, -68, -1), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.SetTexture 0, Texture_Background_Shop
    D3DDevice.SetStreamSource 0, VBuffer_Background, Len(Background(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 60
    
    D3DXMatrixLookAtLH matView, MakeVector(0, 0, 124), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DDevice.SetTexture 0, Texture_Front_Shop(0, 0, Activeebene_shop(0, 0))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop1(Int(Ground_Shop(0, 0))), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -4.8, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Front_Shop(0, 1, Activeebene_shop(0, 1))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop1(Int(Ground_Shop(0, 1))), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -4.7, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Front_Shop(0, 2, Activeebene_shop(0, 2))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop1(Int(Ground_Shop(0, 2))), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -4.7, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Extras_gross_Shop(Activeebene_shop(0, 3))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop1(Int(Ground_Shop(0, 3))), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DXMatrixIdentity matView
    D3DDevice.SetTransform D3DTS_VIEW, matView

    D3DXMatrixLookAtLH matView, MakeVector(0, 0, 124), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 6.7, 0, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Front_Shop(0, 0, Activeebene_shop(1, 0))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop1(Int(Ground_Shop(1, 0))), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -4.8, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Front_Shop(1, 1, Activeebene_shop(1, 1))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop1(Int(Ground_Shop(1, 1))), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 0, -4.7, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Front_Shop(1, 2, Activeebene_shop(1, 2))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop1(Int(Ground_Shop(1, 2))), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -0.1, -4.7, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Extras_Shop(s_ExtrasSlot(1))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop2(Int(Board)), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, 2.1, 0, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Extras_Shop(s_ExtrasSlot(0))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop2(Int(Board)), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2

    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -4.2, 0, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld

    D3DDevice.SetTexture 0, Texture_Extras_Shop(s_ExtrasSlot(2))
    D3DDevice.SetStreamSource 0, VBuffer_Frontground_shop2(Int(Board)), Len(Frontground(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DXMatrixIdentity matView
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    If ebene <> 2 Then
        TextRect.Top = Int((530 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((550 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((20 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((40 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(0)) & "x", TextRect, DT_TOP Or DT_LEFT
        
        TextRect.Top = Int((530 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((550 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((80 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((100 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(1)) & "x", TextRect, DT_TOP Or DT_LEFT
        
        TextRect.Top = Int((530 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((550 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((140 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((160 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(2)) & "x", TextRect, DT_TOP Or DT_LEFT
    
        TextRect.Top = Int((530 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((550 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((200 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((220 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(3)) & "x", TextRect, DT_TOP Or DT_LEFT
        
        TextRect.Top = Int((530 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((550 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((260 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((280 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(4)) & "x", TextRect, DT_TOP Or DT_LEFT
    
        TextRect.Top = Int((735 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((755 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((40 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((60 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Geld: " & CStr(s_Geld), TextRect, DT_TOP Or DT_LEFT
    
    End If
    
    D3DDevice.EndScene
    
    D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub

Public Sub Render_Level(move As Single, Auswahl As String)
    Dim Buffer As Long, i As Integer, j As Integer, VectorX As Single, VectorZ As Single, GVectorX As Single, GVectorZ As Single
    
    fnt.Name = "Arial"
    fnt.Size = Int((10 / 1024) * D3DWindow.BackBufferWidth) '10
    Set MainFontDesc = fnt
    Set MainFont = D3DX.CreateFont(D3DDevice, MainFontDesc.hFont)
    
    D3DDevice.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1#, 0
    
    D3DDevice.BeginScene
        
    D3DXMatrixIdentity matView
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    Lights(0).POSITION = MakeVector(34, 1890, 154 - move)
    D3DDevice.SetLight 0, Lights(0)
    
    D3DXMatrixLookAtLH matView, MakeVector(34 - Player.Acceleration * 100, 35, 154 - move), MakeVector(34, 0, 104 - move), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DXMatrixPerspectiveFovLH matProj, pi / 4, 1, 1, 500
    D3DDevice.SetTransform D3DTS_PROJECTION, matProj
        
    '##############Terrain Anfang#############
    If Auswahl <> "level5" Then
        Buffer = Int((Tlnge * (Tbreite * 2 + 2)) - 2)
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 0, 0, -SetLevel(0)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        If Auswahl = "level1" Then
            D3DDevice.SetTexture 0, Texture(0)
        ElseIf Auswahl = "level2" Then
            D3DDevice.SetTexture 0, Texture(1)
        ElseIf Auswahl = "level3" Then
            D3DDevice.SetTexture 0, Texture(2)
        ElseIf Auswahl = "level4" Then
            D3DDevice.SetTexture 0, Texture(0)
        End If
        D3DDevice.SetStreamSource 0, vbuffer_terrain, Len(Terrain(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, Buffer
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 0, 0, -SetLevel(1)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DDevice.SetStreamSource 0, vbuffer_terrain, Len(Terrain(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, Buffer
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    End If
    '##############Terrain Ende##############
    
    '##############Himmel Anfang#############
    If Auswahl <> "level5" Then
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 0, 0, -SetLevel(0)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        D3DDevice.SetTexture 0, Texture_himmel
        D3DDevice.SetStreamSource 0, vbuffer_himmel_rechts, Len(Himmel_rechts(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.SetStreamSource 0, vbuffer_himmel_links, Len(Himmel_links(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 0, 0, -SetLevel(1)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        D3DDevice.SetTexture 0, Texture_himmel
        D3DDevice.SetStreamSource 0, vbuffer_himmel_rechts, Len(Himmel_rechts(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        D3DDevice.SetStreamSource 0, vbuffer_himmel_links, Len(Himmel_links(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    End If
    '##############Himmel Ende#############
    
    '##############Gras Anfang#############
    If Auswahl = "level1" Or Auswahl = "level4" Then
        D3DDevice.SetRenderState D3DRS_ZENABLE, 1
        D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
        D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
        D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 15, 0, -SetLevel(0)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        D3DDevice.SetTexture 0, Texture3
        D3DDevice.SetStreamSource 0, vbuffer_flora, Len(Grass(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, (Vbreite + 1) * (Vlnge + 1) * 2
    
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 15, 0, -SetLevel(1)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
        D3DDevice.SetStreamSource 0, vbuffer_flora, Len(Grass(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, (Vbreite + 1) * (Vlnge + 1) * 2
    
        D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    End If
    '##############Gras Ende#############
    
    '##############Gimmicks Anfang#############
    For j = 0 To 50
        If Gimmick(j).Typ <> 0 And Gimmick(j).Z <= Player.Z + 50 And Gimmick(j).Z >= Player.Z - 120 Then
            D3DXMatrixIdentity matTemp
            D3DXMatrixScaling matTemp, 0.009, 0.009, 0.009
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixRotationZ matTemp, Gimmick(j).RotationZ
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixRotationY matTemp, Gimmick(j).Rotation
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Gimmick(j).X, Gimmick(j).Y, Gimmick(j).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_LIGHTING, 1
            
            D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
            'D3DDevice.SetVertexShader 0
            For i = 0 To nMaterials(Int(Gimmick(j).Typ)) - 1
                D3DDevice.SetMaterial MeshMaterials(Int(Gimmick(j).Typ), i)
                D3DDevice.SetTexture 0, MeshTextures(Int(Gimmick(j).Typ), i)
                Mesh(Int(Gimmick(j).Typ)).DrawSubset i
            Next i
            D3DDevice.SetRenderState D3DRS_LIGHTING, 0
            D3DDevice.SetVertexShader Lit_FVF
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Next j
    '##############Gimmicks Ende#############
    
    '##############Player Anfang#############

    If Player.Typ <> 0 Then
        D3DXMatrixIdentity matTemp
        D3DXMatrixScaling matTemp, 0.007, 0.007, 0.007
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
        D3DXMatrixIdentity matTemp
        D3DXMatrixRotationY matTemp, 180 * (pi / 180)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixRotationZ matTemp, (Player.Acceleration * 2000) * (pi / 180)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, Player.X, Player.Y, Player.Z
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
        D3DDevice.SetRenderState D3DRS_LIGHTING, 1
        
        D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
        D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
        
        'D3DDevice.SetVertexShader 0
        For i = 0 To nMaterials(Player.Typ) - 1
            D3DDevice.SetMaterial MeshMaterials(Player.Typ, i)
            D3DDevice.SetTexture 0, MeshTextures(Player.Typ, i)
            Mesh(Player.Typ).DrawSubset i
        Next i
    End If
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    If Player.Typ = 1 Then
        D3DXMatrixIdentity matTemp
        D3DXMatrixScaling matTemp, 0.007, 0.007, 0.007
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixRotationY matTemp, 180 * (pi / 180)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixRotationZ matTemp, move * 150 * (pi / 180)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, Player.X, Player.Y, Player.Z
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
        D3DDevice.SetRenderState D3DRS_LIGHTING, 1
        
        D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
        D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
        
        'D3DDevice.SetVertexShader 0
        For i = 0 To nMaterials(0) - 1
            D3DDevice.SetMaterial MeshMaterials(0, i)
            D3DDevice.SetTexture 0, MeshTextures(0, i)
            Mesh(0).DrawSubset i
        Next i
    End If
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    If Player.Typ = 5 Or Player.Typ = 4 Then
        D3DXMatrixIdentity matTemp
        D3DXMatrixScaling matTemp, 0.032, 0.032, 0.032
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    Else
        D3DXMatrixIdentity matTemp
        D3DXMatrixScaling matTemp, 0.025, 0.025, 0.025
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixRotationZ matTemp, (Player.Acceleration * 2000) * (pi / 180)
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, Player.X, Player.Y, Player.Z
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetRenderState D3DRS_SRCBLEND, 2
    D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
    
    If Player.Shild > 0 Then
        For i = 0 To nMaterials(6) - 1
            D3DDevice.SetMaterial MeshMaterials(6, i)
            D3DDevice.SetTexture 0, MeshTextures(6, i)
            Mesh(6).DrawSubset i
        Next i
    End If
    
    D3DDevice.SetRenderState D3DRS_LIGHTING, 0
    D3DDevice.SetVertexShader Lit_FVF
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    '##############Player Ende#############
    
    '##############Gegner Anfang#############
    For j = 0 To 50
        If Gegner(j).Typ <> 0 And Gegner(j).Z <= Player.Z + 50 And Gegner(j).Z >= Player.Z - 100 Then
            D3DXMatrixIdentity matTemp
            D3DXMatrixScaling matTemp, 0.05, 0.05, 0.05
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixRotationZ matTemp, Gegner(j).Vibration * (pi / 180)
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Gegner(j).X, Gegner(j).Y, Gegner(j).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_LIGHTING, 1
            
            D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
            'D3DDevice.SetVertexShader 0
            For i = 0 To nMaterials(Gegner(j).Typ) - 1
                D3DDevice.SetMaterial MeshMaterials(Gegner(j).Typ, i)
                D3DDevice.SetTexture 0, MeshTextures(Gegner(j).Typ, i)
                Mesh(Gegner(j).Typ).DrawSubset i
            Next i
            D3DDevice.SetRenderState D3DRS_LIGHTING, 0
            D3DDevice.SetVertexShader Lit_FVF
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Next j
    '##############Gegner Ende#############
    
    '##############Wasser Anfang#############
    If Auswahl <> "level5" Then
        If Auswahl = "level1" Or Auswahl = "level2" Then
            Buffer = Int((Wlnge * (Wbreite * 2 + 2)) - 2)
        
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, 0, 0.5, 0 - move
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_SRCBLEND, 3
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
            D3DDevice.SetTexture 0, Texture2
            D3DDevice.SetStreamSource 0, vbuffer_waves, Len(Waves(0))
            D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, Buffer
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Else
        Buffer = Int((Wlnge * (Wbreite * 2 + 2)) - 2)
        
        D3DXMatrixPerspectiveFovLH matProj, pi / 4, 1.3, 1, 500
        D3DDevice.SetTransform D3DTS_PROJECTION, matProj
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, 0, 0.5, 0 - move
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
        D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
        D3DDevice.SetRenderState D3DRS_SRCBLEND, 3
        D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
        D3DDevice.SetTexture 0, Texture(3)
        D3DDevice.SetStreamSource 0, vbuffer_waves, Len(Waves(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, Buffer
        D3DDevice.SetTexture 0, Texture(4)
        D3DDevice.SetStreamSource 0, vbuffer_waves, Len(Waves(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, Buffer
        D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
        
        D3DXMatrixPerspectiveFovLH matProj, pi / 4, 1, 1, 500
        D3DDevice.SetTransform D3DTS_PROJECTION, matProj
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    End If
    '##############Wasser Ende#############
    
    '##############Raketen Anfang#############
    For j = 0 To 20
        If Rakete(j).Typ <> 0 And Rakete(j).Z <= Player.Z + 50 And Rakete(j).Z >= Player.Z - 120 Then
            D3DXMatrixIdentity matTemp
            D3DXMatrixScaling matTemp, 0.02, 0.02, 0.02
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixRotationX matTemp, 270 * (pi / 180)
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            If Rakete(j).Typ = 4 Then
            
                VectorZ = (Sqr((Rakete(j).Z - Gegner(Rakete(j).Victim).Z) ^ 2))
                VectorX = (Sqr((Rakete(j).X - Gegner(Rakete(j).Victim).X) ^ 2))

                GVectorZ = VectorZ / (Sqr(VectorZ ^ 2 + VectorX ^ 2))
                GVectorX = VectorX / (Sqr(VectorZ ^ 2 + VectorX ^ 2))
                
                If Rakete(j).Z >= Gegner(Rakete(j).Victim).Z And Rakete(j).X >= Gegner(Rakete(j).Victim).X Then
                    D3DXMatrixIdentity matTemp
                    D3DXMatrixRotationY matTemp, -arcussinus(-GVectorX) * (pi / 180)
                    D3DXMatrixMultiply matWorld, matWorld, matTemp
                    D3DDevice.SetTransform D3DTS_WORLD, matWorld
                ElseIf Rakete(j).Z >= Gegner(Rakete(j).Victim).Z And Rakete(j).X <= Gegner(Rakete(j).Victim).X Then
                    D3DXMatrixIdentity matTemp
                    D3DXMatrixRotationY matTemp, -arcussinus(GVectorX) * (pi / 180)
                    D3DXMatrixMultiply matWorld, matWorld, matTemp
                    D3DDevice.SetTransform D3DTS_WORLD, matWorld
                ElseIf Rakete(j).Z <= Gegner(Rakete(j).Victim).Z And Rakete(j).X >= Gegner(Rakete(j).Victim).X Then
                    D3DXMatrixIdentity matTemp
                    D3DXMatrixRotationY matTemp, (arcussinus(-GVectorX) + 180) * (pi / 180)
                    D3DXMatrixMultiply matWorld, matWorld, matTemp
                    D3DDevice.SetTransform D3DTS_WORLD, matWorld
                ElseIf Rakete(j).Z <= Gegner(Rakete(j).Victim).Z And Rakete(j).X <= Gegner(Rakete(j).Victim).X Then
                    D3DXMatrixIdentity matTemp
                    D3DXMatrixRotationY matTemp, (arcussinus(GVectorX) + 180) * (pi / 180)
                    D3DXMatrixMultiply matWorld, matWorld, matTemp
                    D3DDevice.SetTransform D3DTS_WORLD, matWorld
                End If
               
            End If
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Rakete(j).X, Rakete(j).Y, Rakete(j).Z - 2
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
            D3DDevice.SetRenderState D3DRS_LIGHTING, 1
            'D3DDevice.SetVertexShader 0
            For i = 0 To nMaterials(Rakete(j).Typ + 6) - 1
                D3DDevice.SetMaterial MeshMaterials(Rakete(j).Typ + 6, i)
                D3DDevice.SetTexture 0, MeshTextures(Rakete(j).Typ + 6, i)
                Mesh(Rakete(j).Typ + 6).DrawSubset i
            Next i
            D3DDevice.SetRenderState D3DRS_LIGHTING, 0
            D3DDevice.SetVertexShader Lit_FVF
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Next j
    '##############Raketen Ende#############
    
    '##############Shot Anfang#############
    D3DDevice.SetRenderState D3DRS_ZENABLE, 0
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    D3DDevice.SetTexture 0, Texture_Shot(Primary.Typ - 1)
    For i = 0 To 100
        If Shot(i).Typ <> 0 And Shot(i).Z <= Player.Z + 50 And Shot(i).Z >= Player.Z - 120 And (Int(Shot(i).Shoot >= 0) And Int(Shot(i).Shoot <= 100)) Then
            If Shot(i).Typ = 3 Then
                D3DDevice.SetTexture 0, Texture_Shot(Shot(i).Typ - 1)
                
                D3DDevice.SetRenderState D3DRS_SRCBLEND, 3
                D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
                For j = -5 To Shot(i).Shoot * 8
                    D3DXMatrixIdentity matTemp
                    D3DXMatrixTranslation matTemp, Shot(i).X, Shot(i).Y, Shot(i).Z - j / 8 - 2
                    D3DXMatrixMultiply matWorld, matWorld, matTemp
                    D3DDevice.SetTransform D3DTS_WORLD, matWorld
                
                    D3DDevice.SetStreamSource 0, vbuffer_Shot(Shot(i).Typ - 1, Int(Shot(i).Shoot)), Len(vShot(0))
                    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
                    
                    D3DXMatrixIdentity matWorld
                    D3DDevice.SetTransform D3DTS_WORLD, matWorld
                Next j
            Else
                D3DXMatrixIdentity matTemp
                D3DXMatrixRotationZ matTemp, (Shot(i).Rotation * 2000) * (pi / 180)
                D3DXMatrixMultiply matWorld, matWorld, matTemp
                D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
                D3DDevice.SetTexture 0, Texture_Shot(Shot(i).Typ - 1)
                
                D3DDevice.SetRenderState D3DRS_SRCBLEND, 2
                D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
    
                D3DXMatrixIdentity matTemp
                D3DXMatrixTranslation matTemp, Shot(i).X, Shot(i).Y, Shot(i).Z
                D3DXMatrixMultiply matWorld, matWorld, matTemp
                D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
                D3DDevice.SetStreamSource 0, vbuffer_Shot(Shot(i).Typ - 1, Int(Shot(i).Shoot)), Len(vShot(0))
                D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
                
                D3DXMatrixIdentity matWorld
                D3DDevice.SetTransform D3DTS_WORLD, matWorld
            End If
        End If
    Next i
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    '##############Shot Ende#############
    
    '##############ENEMYShot Anfang#############
    D3DDevice.SetRenderState D3DRS_ZENABLE, 0
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    D3DDevice.SetTexture 0, Texture_Shot(1)
    For i = 0 To 100
        If gShot(i).Typ <> 0 And gShot(i).Z <= Player.Z + 50 And gShot(i).Z >= Player.Z - 120 And (Int(gShot(i).Shoot) >= 0 And Int(gShot(i).Shoot) <= 100) Then
            D3DDevice.SetTexture 0, Texture_Shot(gShot(i).Typ - 1)
            
            D3DDevice.SetRenderState D3DRS_SRCBLEND, 2
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE

            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, gShot(i).X, gShot(i).Y, gShot(i).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
            D3DDevice.SetStreamSource 0, vbuffer_Shot(gShot(i).Typ - 1, Int(gShot(i).Shoot)), Len(vShot(0))
            D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Next i
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    '##############ENEMYShot Ende#############
    
    '##############Rauch Anfang#############
    D3DDevice.SetRenderState D3DRS_ZENABLE, 0
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    D3DDevice.SetRenderState D3DRS_SRCBLEND, 3
    D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
    D3DDevice.SetTexture 0, Texture_Shot(0)
    For i = 0 To 1000
        If Smoke(i).Typ = 1 And Smoke(i).Z <= Player.Z + 50 And Smoke(i).Z >= Player.Z - 120 Then
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Smoke(i).X, Smoke(i).Y, Smoke(i).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
            If Smoke(i).Gone >= 0 And Smoke(i).Gone <= 100 Then
                D3DDevice.SetStreamSource 0, vbuffer_Smoke(Int(Smoke(i).Gone)), Len(vSmoke(0))
                D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
            End If
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Next i
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    '##############Rauch Ende#############
    
    '##############Explosion Anfang#############
    D3DDevice.SetRenderState D3DRS_ZENABLE, 0
    For i = 0 To 10
        If Explosion(i).Typ <> 0 And (Explosion(i).Gone >= 0 And Explosion(i).Gone <= 100) Then
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixScaling matTemp, 0.05, 0.05, 0.05
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Explosion(i).X, Explosion(i).Y, Explosion(i).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_SRCBLEND, Explosion(i).Blend
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
            D3DDevice.SetTexture 0, Texture_Shot(0)
            If Explosion(i).Typ = 1 And (Int(Explosion(i).Gone) > 0 And Int(Explosion(i).Gone) < 100) Then
                D3DDevice.SetStreamSource 0, VBuffer_Explosion1(Int(Explosion(i).Gone)), Len(Partikel(0))
            ElseIf Explosion(i).Typ = 2 And (Int(Explosion(i).Gone) > 0 And Int(Explosion(i).Gone) < 100) Then
                D3DDevice.SetStreamSource 0, VBuffer_Explosion2(Int(Explosion(i).Gone)), Len(Partikel(0))
            ElseIf Explosion(i).Typ = 3 And (Int(Explosion(i).Gone) > 0 And Int(Explosion(i).Gone) < 100) Then
                D3DDevice.SetStreamSource 0, VBuffer_Explosion3(Int(Explosion(i).Gone)), Len(Partikel(0))
            End If
            D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, TMenge
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixScaling matTemp, 0.04 + Explosion(i).Gone / 4, 0.04 + Explosion(i).Gone / 4, 0.04 + Explosion(i).Gone / 4
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
             
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Explosion(i).X, Explosion(i).Y + (i / 10), Explosion(i).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_SRCBLEND, 2 '2 (hell) oder 3 (etwas dunkler)
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
            D3DDevice.SetTexture 0, Texture_Shockwave
            If Explosion(i).Typ = 1 And (Int(Explosion(i).Gone) > 0 And Int(Explosion(i).Gone) < 100) Then
                D3DDevice.SetStreamSource 0, VBuffer_Shockwave(0, Int(Explosion(i).Gone)), Len(Shock(0))
            ElseIf Explosion(i).Typ = 2 And (Int(Explosion(i).Gone) > 0 And Int(Explosion(i).Gone) < 100) Then
                D3DDevice.SetStreamSource 0, VBuffer_Shockwave(1, Int(Explosion(i).Gone)), Len(Shock(0))
            ElseIf Explosion(i).Typ = 3 And (Int(Explosion(i).Gone) > 0 And Int(Explosion(i).Gone) < 100) Then
                D3DDevice.SetStreamSource 0, VBuffer_Shockwave(2, Int(Explosion(i).Gone)), Len(Shock(0))
            End If
            D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Next i
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    '##############Explosion Ende#############
    
    '##############Shockwave Anfang#############
    D3DDevice.SetRenderState D3DRS_ZENABLE, 0
    For i = 0 To 10
        If Shockwave(i).Typ <> 0 And (Int(Shockwave(i).Gone) >= 0 And Int(Shockwave(i).Gone <= 100)) Then
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixScaling matTemp, 0.05 + Shockwave(i).Gone / 5, 0.05 + Shockwave(i).Gone / 5, 0.05 + Shockwave(i).Gone / 5
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Shockwave(i).X, Shockwave(i).Y, Shockwave(i).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_SRCBLEND, 2
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
            D3DDevice.SetTexture 0, Texture_Shockwave
            D3DDevice.SetStreamSource 0, VBuffer_Shockwave(Shockwave(i).Typ - 1, Int(Shockwave(i).Gone)), Len(Shock(0))
            D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
        End If
    Next i
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    '##############Shockwave Ende#############

    '##############Treffer Anfang#############
    D3DDevice.SetRenderState D3DRS_ZENABLE, 0
    For i = 0 To 10
        If Treffer(i).Typ <> 0 And (Treffer(i).Gone >= 0 And Treffer(i).Gone <= 100) Then
            D3DXMatrixIdentity matTemp
            D3DXMatrixScaling matTemp, 0.05, 0.05, 0.05
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DXMatrixIdentity matTemp
            D3DXMatrixTranslation matTemp, Treffer(i).X, Treffer(i).Y, Treffer(i).Z
            D3DXMatrixMultiply matWorld, matWorld, matTemp
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
            
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
            D3DDevice.SetRenderState D3DRS_SRCBLEND, 3
            D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
            D3DDevice.SetTexture 0, Texture_Shot(0)
            If Treffer(i).Richtung = 1 Then
                D3DDevice.SetStreamSource 0, VBuffer_Treffer_Links(Int(Treffer(i).Gone)), Len(PartikelTreffer(0))
                D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, TPMenge
            Else 'If Treffer(I).Richtung = -1 Then
                D3DDevice.SetStreamSource 0, VBuffer_Treffer_Rechts(Int(Treffer(i).Gone)), Len(PartikelTreffer(0))
                D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, TPMenge
            End If
            D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
            
            D3DXMatrixIdentity matWorld
            D3DDevice.SetTransform D3DTS_WORLD, matWorld
        End If
    Next i
    D3DDevice.SetRenderState D3DRS_ZENABLE, 1
    '##############Treffer Ende#############
    
    '##############Menue, Moviestrips Anfang#############
    D3DXMatrixIdentity matView
    D3DXMatrixLookAtLH matView, MakeVector(19.3, 0, 5.7), MakeVector(19.3, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixScaling matTemp, 0.3, 0.3, 0.3
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DXMatrixPerspectiveFovLH matProj, pi / 4, 1, 1, 500
    D3DDevice.SetTransform D3DTS_PROJECTION, matProj
    
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 1
    D3DDevice.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
    D3DDevice.SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
    
    D3DDevice.SetTexture 0, Texture_Weapon(Primary.Typ - 1)
    D3DDevice.SetStreamSource 0, vbuffer_menue_primary, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    If ((Player.Armor / Player.Energy) * 100) >= -50 And ((Player.Armor / Player.Energy) * 100) < 30 Then
        D3DDevice.SetTexture 0, Texture_energy(5)
    ElseIf ((Player.Armor / Player.Energy) * 100) >= 30 And ((Player.Armor / Player.Energy) * 100) < 40 Then
        D3DDevice.SetTexture 0, Texture_energy(4)
    ElseIf ((Player.Armor / Player.Energy) * 100) >= 40 And ((Player.Armor / Player.Energy) * 100) < 60 Then
        D3DDevice.SetTexture 0, Texture_energy(3)
    ElseIf ((Player.Armor / Player.Energy) * 100) >= 60 And ((Player.Armor / Player.Energy) * 100) < 80 Then
        D3DDevice.SetTexture 0, Texture_energy(2)
    ElseIf ((Player.Armor / Player.Energy) * 100) >= 80 And ((Player.Armor / Player.Energy) * 100) < 90 Then
        D3DDevice.SetTexture 0, Texture_energy(1)
    ElseIf ((Player.Armor / Player.Energy) * 100) >= 90 Then
        D3DDevice.SetTexture 0, Texture_energy(0)
    End If
    D3DDevice.SetStreamSource 0, vbuffer_menue_energy, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    D3DDevice.SetTexture 0, Texture_Extras(s_ExtrasSlot(2))
    D3DDevice.SetStreamSource 0, vbuffer_menue_extra1, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    D3DDevice.SetTexture 0, Texture_Extras(s_ExtrasSlot(1))
    D3DDevice.SetStreamSource 0, vbuffer_menue_extra2, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    D3DDevice.SetTexture 0, Texture_Extras(s_ExtrasSlot(0))
    D3DDevice.SetStreamSource 0, vbuffer_menue_extra3, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DXMatrixIdentity matView
    D3DXMatrixLookAtLH matView, MakeVector(0, 0, 27), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    If bRun = False Then
        If bStart = False Then
            D3DDevice.SetTexture 0, Texture_Pause(2)
        ElseIf bStart = True Then
            D3DDevice.SetTexture 0, Texture_Pause(SituationPause)
        End If
        D3DDevice.SetStreamSource 0, vbuffer_menue_pause, Len(TriStrip(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2

        D3DDevice.SetRenderState D3DRS_LIGHTING, 1
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixRotationY matTemp, -(EscRun * 10) * (pi / 180)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixRotationZ matTemp, -(EscRun * 10) * (pi / 180)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld

        D3DXMatrixIdentity matTemp
        D3DXMatrixRotationX matTemp, -(EscRun * 10) * (pi / 180)
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixTranslation matTemp, -1240, 200, 0
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        D3DXMatrixIdentity matTemp
        D3DXMatrixScaling matTemp, 0.0004, 0.0004, 0.0004
        D3DXMatrixMultiply matWorld, matWorld, matTemp
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
        
        Lights(0).POSITION = MakeVector(34, 27000, 154)
        D3DDevice.SetLight 0, Lights(0)
        
        D3DXMatrixLookAtLH matView, MakeVector(2, 2, 2), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
        D3DDevice.SetTransform D3DTS_VIEW, matView
        
        'D3DDevice.SetVertexShader 0
        For i = 0 To nMaterials(12) - 1
            D3DDevice.SetMaterial MeshMaterials(12, i)
            D3DDevice.SetTexture 0, MeshTextures(12, i)
            Mesh(12).DrawSubset i
        Next i
        D3DDevice.SetVertexShader Lit_FVF
        D3DDevice.SetRenderState D3DRS_LIGHTING, 0
        
        D3DXMatrixIdentity matWorld
        D3DDevice.SetTransform D3DTS_WORLD, matWorld
    End If
    
    Lights(0).POSITION = MakeVector(34, 1890, 154 - move)
    D3DDevice.SetLight 0, Lights(0)
    
    D3DXMatrixIdentity matView
    D3DXMatrixLookAtLH matView, MakeVector(0, 0, 27), MakeVector(0, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    If bSieg = True Then
        D3DDevice.SetTexture 0, Texture_stats
        D3DDevice.SetStreamSource 0, vbuffer_menue_sieg, Len(TriStrip(0))
        D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    End If
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixRotationZ matTemp, -(Player.Acceleration * 2000) * (pi / 180)
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixTranslation matTemp, -3.9, -9.55, 0
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetTexture 0, Texture_neigung
    D3DDevice.SetStreamSource 0, vbuffer_menue_neigung, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DXMatrixIdentity matView
    D3DXMatrixLookAtLH matView, MakeVector(19.3, 0, 5.7), MakeVector(19.3, 0, 0), MakeVector(0, 1, 0)
    D3DDevice.SetTransform D3DTS_VIEW, matView
    
    D3DXMatrixIdentity matTemp
    D3DXMatrixScaling matTemp, 0.3, 0.3, 0.3
    D3DXMatrixMultiply matWorld, matWorld, matTemp
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetTexture 0, Texture_menue
    D3DDevice.SetStreamSource 0, vbuffer_menue, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    D3DDevice.SetTexture 0, Texture_menue2
    D3DDevice.SetStreamSource 0, vbuffer_menue2, Len(TriStrip(0))
    D3DDevice.DrawPrimitive D3DPT_TRIANGLESTRIP, 0, 2
    
    'D3DDevice.SetStreamSource 0, vbuffer_MovieStrips, Len(MovieStrip(0))
    'D3DDevice.DrawPrimitive D3DPT_TRIANGLELIST, 0, 4
    
    D3DXMatrixIdentity matWorld
    D3DDevice.SetTransform D3DTS_WORLD, matWorld
    
    D3DDevice.SetRenderState D3DRS_ALPHABLENDENABLE, 0
    
    '##############Menue, Moviestrips Ende#############
    
    TextRect.Top = 0
    TextRect.bottom = Int((20 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((15 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((35 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, CStr(FPS_Current) & " fps", TextRect, DT_TOP Or DT_LEFT
    
    TextRect.Top = Int((20 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((40 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((15 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((35 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, CStr(move) & " moves", TextRect, DT_TOP Or DT_LEFT
    
    TextRect.Top = Int((195 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((215 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((850 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((870 / 1024) * D3DWindow.BackBufferWidth)
    If RaketenAuswahl = 1 Then
        D3DX.DrawText MainFont, &HFFF55500, CStr(s_RaketenSlot(0)) & "x", TextRect, DT_TOP Or DT_LEFT
    Else
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(0)) & "x", TextRect, DT_TOP Or DT_LEFT
    End If
    TextRect.Top = Int((195 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((215 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((880 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((900 / 1024) * D3DWindow.BackBufferWidth)
    If RaketenAuswahl = 2 Then
        D3DX.DrawText MainFont, &HFFF55500, CStr(s_RaketenSlot(1)) & "x", TextRect, DT_TOP Or DT_LEFT
    Else
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(1)) & "x", TextRect, DT_TOP Or DT_LEFT
    End If
    TextRect.Top = Int((195 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((215 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((910 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((930 / 1024) * D3DWindow.BackBufferWidth)
    If RaketenAuswahl = 3 Then
        D3DX.DrawText MainFont, &HFFF55500, CStr(s_RaketenSlot(2)) & "x", TextRect, DT_TOP Or DT_LEFT
    Else
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(2)) & "x", TextRect, DT_TOP Or DT_LEFT
    End If
    TextRect.Top = Int((195 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((215 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((940 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((960 / 1024) * D3DWindow.BackBufferWidth)
    If RaketenAuswahl = 4 Then
        D3DX.DrawText MainFont, &HFFF55500, CStr(s_RaketenSlot(3)) & "x", TextRect, DT_TOP Or DT_LEFT
    Else
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(3)) & "x", TextRect, DT_TOP Or DT_LEFT
    End If
    TextRect.Top = Int((195 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((215 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((970 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((990 / 1024) * D3DWindow.BackBufferWidth)
    If RaketenAuswahl = 5 Then
        D3DX.DrawText MainFont, &HFFF55500, CStr(s_RaketenSlot(4)) & "x", TextRect, DT_TOP Or DT_LEFT
    Else
        D3DX.DrawText MainFont, &HFFFFCC00, CStr(s_RaketenSlot(4)) & "x", TextRect, DT_TOP Or DT_LEFT
    End If
    
    TextRect.Top = Int((590 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((610 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((825 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    If Auswahl = "level1" Then D3DX.DrawText MainFont, &HFFFFCC00, "Auentemperatur: 22C", TextRect, DT_TOP Or DT_LEFT
    If Auswahl = "level2" Then D3DX.DrawText MainFont, &HFFFFCC00, "Auentemperatur: -15C", TextRect, DT_TOP Or DT_LEFT
    If Auswahl = "level3" Then D3DX.DrawText MainFont, &HFFFFCC00, "Auentemperatur: 41C", TextRect, DT_TOP Or DT_LEFT
    If Auswahl = "level4" Then D3DX.DrawText MainFont, &HFFFFCC00, "Auentemperatur: 30C", TextRect, DT_TOP Or DT_LEFT
    If Auswahl = "level5" Then D3DX.DrawText MainFont, &HFFFFCC00, "Auentemperatur: -273C", TextRect, DT_TOP Or DT_LEFT
        
    TextRect.Top = Int((610 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((630 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((825 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Innentemperatur: 21C", TextRect, DT_TOP Or DT_LEFT
        
    TextRect.Top = Int((630 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((650 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((825 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Geschwindigkeit: " & CStr(Player.Tempo) & " km/h", TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((650 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((670 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((825 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Triebwerkshitze: " & Triebwerkshitze & "C", TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((670 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((690 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((825 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Neigung: " & CStr(Int(Player.Acceleration * 4000)) & "", TextRect, DT_TOP Or DT_LEFT
        
    TextRect.Top = Int((690 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((710 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((825 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Hhe: 50m ", TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((710 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((730 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((725 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((845 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Punktestand: " & s_Punkte, TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((340 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((36 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((865 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((885 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, CStr(Int((Player.Armor / Player.Energy) * 100)) & "%", TextRect, DT_TOP Or DT_LEFT
       
    TextRect.Top = Int((400 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((420 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((865 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((885 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, CStr(Player.Armor) & "/" & CStr(Player.Energy) & "/" & CStr(Player.Shild), TextRect, DT_TOP Or DT_LEFT
      
    '-->####################links#############################
    
    TextRect.Top = Int((590 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((610 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((25 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((45 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Kills ", TextRect, DT_TOP Or DT_LEFT
        
    TextRect.Top = Int((610 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((630 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((25 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((45 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Gegner zerstrt: " & Destroyed, TextRect, DT_TOP Or DT_LEFT
        
    TextRect.Top = Int((630 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((650 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((25 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((45 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Treffer: " & Hits, TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((650 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((670 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((25 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((45 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Geschossen: " & Shoted, TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((670 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((690 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((25 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((45 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Trefferquote: " & CInt(((Hits + 0.1) / (Shoted + 0.1)) * 100) & "%", TextRect, DT_TOP Or DT_LEFT
         
    TextRect.Top = Int((690 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((710 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((25 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((45 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Actionbonus: " & Action, TextRect, DT_TOP Or DT_LEFT
      
    TextRect.Top = Int((710 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.bottom = Int((730 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Right = Int((25 / 1024) * D3DWindow.BackBufferWidth)
    TextRect.Left = Int((45 / 1024) * D3DWindow.BackBufferWidth)
    D3DX.DrawText MainFont, &HFFFFCC00, "Punktestand: " & s_Punkte, TextRect, DT_TOP Or DT_LEFT
      
    '-->##########################################STATISTIKEN
    
    '-->####################links#############################
    If bSieg = True Then
        TextRect.Top = Int((290 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((310 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((425 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((445 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Statistiken ", TextRect, DT_TOP Or DT_LEFT
            
        TextRect.Top = Int((310 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((330 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((425 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((445 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Gegner zerstrt: " & Destroyed, TextRect, DT_TOP Or DT_LEFT
            
        TextRect.Top = Int((330 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((350 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((425 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((445 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Treffer: " & Hits, TextRect, DT_TOP Or DT_LEFT
          
        TextRect.Top = Int((350 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((370 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((425 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((445 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Geschossen: " & Shoted, TextRect, DT_TOP Or DT_LEFT
          
        TextRect.Top = Int((370 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((390 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((425 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((445 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Trefferquote: " & CInt(((Hits + 0.1) / (Shoted + 0.1)) * 100) & "%", TextRect, DT_TOP Or DT_LEFT
             
        TextRect.Top = Int((390 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((410 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((425 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((445 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Actionbonus: " & Action, TextRect, DT_TOP Or DT_LEFT
          
        TextRect.Top = Int((410 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.bottom = Int((430 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Right = Int((425 / 1024) * D3DWindow.BackBufferWidth)
        TextRect.Left = Int((445 / 1024) * D3DWindow.BackBufferWidth)
        D3DX.DrawText MainFont, &HFFFFCC00, "Punktestand: " & CLng((Int(DestroyedEnemy) * 10) * ((Hits / (Shoted + 0.1)) * 100) + Action * 250), TextRect, DT_TOP Or DT_LEFT
    End If
    
    D3DDevice.EndScene
    
    D3DDevice.Present ByVal 0, ByVal 0, 0, ByVal 0
End Sub
